/*
 * by Dirk Meyer (dinoex)
 * Copyright (C) 2004-2009 Dirk Meyer
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the GNU General Public License.  More information is
 * available in the LICENSE file.
 *
 * If you received this file without documentation, it can be
 * downloaded from http://iroffer.dinoex.net/
 *
 * $Id: dinoex_misc.h,v 1.106 2009/02/21 20:06:08 cvs Exp $
 *
 */

extern xdcc xdcc_statefile;
extern xdcc xdcc_listfile;

int hide_pack(const xdcc *xd);
int check_lock(const char* lockstr, const char* pwd);
int number_of_pack(xdcc *pack);
int check_level(char prefix);

void set_support_groups(void);
void stoplist(const char *nick);
unsigned long get_next_transfer_time(void);
void add_new_transfer_time(xdcc *xd);
void guess_end_transfers(void);
void guess_end_cleanup(void);
int notifyqueued_nick(const char *nick);
void notifyqueued(void);
void startup_dinoex(void);
void config_dinoex(void);
void shutdown_dinoex(void);
void rehash_dinoex(void);
void update_hour_dinoex(int hour, int minute);
void check_new_connection(transfer *const tr);
char *grep_to_fnmatch(const char *grep);
int fnmatch_xdcc(const char *match, xdcc *xd);

int disk_full(const char *path);

char *get_user_modes(void);
char *get_nickserv_pass(void);

xdcc *get_xdcc_pack(int pack);
int access_need_level(const char *nick, const char *text);
xdcc *get_download_pack(const char* nick, const char* hostmask, int pack, int man, const char* text, int restr);

void lost_nick(const char *nick);

int is_unsave_directory(const char *dir);

void logfile_add(const char *logfile, const char *line);

char *get_current_bandwidth(void);
char *transfer_limit_exceeded_msg(int ii);

int verify_uploadhost(const char *hostmask);
void clean_uploadhost(void);

char *user_getdatestr(char* str, time_t Tp, int len);

char *get_grouplist_access(const char *nick);
const char *get_grouplist_channel(const char *dest);

int verify_cidr(irlist_t *list, const ir_sockaddr_union_t *remote);

void free_channel_data(channel_t *ch);

void auto_rehash(void);

/* End of File */
